'
' Step 4: Data transfer, Assembly to spin, cog to hub.
'
' In this tutorial the assembly code loads data into the hub ram using the wrlong command, this data is then accessable
' from the spin code.

' To make this code accessable to all it does something quite useless it makes the VGA leds on the demoboard do a
' KnightRider/Cylon effect.  It does this by loading a variable in cog ram with one and then it shifts it left 8 times
' and then right 8 times with a little time delay between each shift.  The cog ram variable is moved into hub ram
' every time it is changed where the spin code in the main program can accesss it via the helper function getcount.
  
       
VAR

  long  cog                           ' This is in hub ram
  long  count                       

PUB start : okay

okay := cog := cognew(@entry, @count) + 1    '** NOTE: we send the cog the address to the hub ram variables used **  

PUB stop

'' Stop flashing - frees a cog

  if cog
    cogstop(cog~ -  1) 

PUB getcount : cow                           ' Used by spin programs to set on_time

cow := count

DAT

entry                 ' When the cog starts par is initialized with the address passed in the coginit command
                      ' in this case it was passed @count
                      
                      mov     p,par           ' load parameter pointer into p (points to global variables)
                                              ' p is just a copy and keeps par unchanged for later.

                      mov     _count,#1       ' Count is the variable that will be loaded into hub ram
                      mov     t,#8            ' t is a counter
                      mov     time, cnt
                      add     time,delay

                      ' Now we make the effect, note this is coded for clarity, it could be done differently.
                                               
:loop1                wrlong  _count,p         ' Write the cog variable _count to the hub variable count
                      shl     _count,#1        ' shift the bit left
                      waitcnt time,delay       ' wait               
                      djnz    t,#:loop1        ' and loop away

                      mov     t,#8             ' when 8 shifts are done reset the counter variable

:loop2                shr     _count,#1        ' Shift the bit back the other way
                      wrlong  _count,p         ' Write the cog variable _count to the hub variable count                      
                      waitcnt time,delay                      
                      djnz    t,#:loop2        ' and loop away

                      mov     _count,#1        ' Reset the variable and keep on looping
                      mov     t,#8
                      jmp     #:loop1

                      ' These variables are in cog ram!                 
' Uninitialized data

delay                long    2_000_000          ' Sets speed of Knight Rider effect, Michael
t                    long    0

time                 res     1
p                    res     1
_count               res     1
