' Step 1
' Flash an LED, this object allows a cog to be started with a simple assembly program running in it.
' The on time and off time are defined in the dat section,
' The pin is passed to the start function and loaded into the pinmask variable before the cog is loaded so no clever business
' is required to get this information into the assembly program.

' Waitcnt is used, notice the first variable is the target, when cnt equals this the program will continue.  The second value
' is then added to the target variable ready for the next waitcnt, this saves an add command. 


VAR

  long  cog                           ' This is in hub ram

PUB start(pin) : okay

pinmask := |<pin                     ' This can be done because pinmask(cog ram) is filled before the data is loaded into
                                     ' the cog, notice pinmask is declared a long not a res.  After the cog is loaded
                                     ' the value cannot be modified in this way.

' Now to start the cog, notice the @entry, look at the assembly, you can see where it will begin

okay := cog := cognew(@entry, 0) + 1  


PUB stop

'' Stop flashing - frees a cog

  if cog
    cogstop(cog~ -  1) 


DAT

entry                  
                      or      dira,pinmask          ' Sets relevant pin to an output
                      or      outa,pinmask          ' Make pin high
                      mov     time,cnt              ' Current clock loaded into time
                      add     time,on_time          ' on_time added to time
                      
:loop                 waitcnt time,off_time         ' waits for time to pass, off_time added to time automatically
                      xor     outa,pinmask          ' toggles pin 
                      waitcnt time,on_time          ' waits for time to pass, on_time added to time automatically
                      xor     outa,pinmask          ' toggles pin 
                      jmp     #:loop                ' loop, the # means that :loop is a literal (something typed into program 
                                                    ' rather than a register).
                      

                       ' These variables are in cog ram!
                        
' Initialized data                                     

on_time              long    10000000                   ' on time in clock cycles
off_time             long    50000000                   ' off time
pinmask              long    0                            

'**** ATTENTION, all res variables MUST come after other variables ************

' Uninitialized data

time                 res     1

