'' ================================================================================================
''
''   File....... jw_bicolor_v3_demo.spin
''   Purpose.... bi-color LED driver demo 
''   Author..... Jon Williams
''   E-mail..... jwilliams@efx-tek.com
''   Started.... 
''   Updated.... 13 MAY 2009 
''
'' ================================================================================================


CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  
  MS_001 = 80_000_000 / 1_000                                   ' ticks per millisecond
  
  
OBJ

  led : "jw_bicolor_v3"

  
VAR


PUB main | idx

  led.start(8, led#LED_OFF, 100, led#LED_OFF, 100, 100)

  repeat                                                        ' loop forever
    repeat idx from led#LED_OFF to led#LED_RED                  ' cycle through LED colors
      led.setcolor(idx)
      waitcnt(MS_001 * 500 + cnt)                               ' hold 0.5 seconds
      
    led.off
    waitcnt(MS_001 * 250 + cnt)
    
    led.setbright(0)
    led.green
    repeat idx from 0 to 100                                    ' fade up green
      led.setbright(idx)
      waitcnt(MS_001 * 20 + cnt)
      
    led.setbright(0)
    led.yellow
    repeat idx from 0 to 100                                    ' fade up yellow
      led.setbright(idx)
      waitcnt(MS_001 * 20 + cnt)
      
    led.setbright(0)
    led.red
    repeat idx from 0 to 100                                    ' fade up red
      led.setbright(idx)
      waitcnt(MS_001 * 20 + cnt)
           
       