{*******************************************************
* (C) 2008 myDanceBot.com, Inc.                        *
********************************************************}
con
  _clkmode = xtal1 + pll16x
  _xinfreq        = 5_000_000
  msec=80_000
  biasUpdate=80_000_000/50 '20ms
  gAvgNum=1 'shifted in code, so change that too
  ACC3D_Addr    = %0011_1010
  accelSCLP=6
  accelSDAP=7
  gyroOutP =5
  gyroInP  =8
  accelS   =1
  accelO   =0
  gyroS    =40
  gyroO    =82535
VAR
  long gyrodone
  long accel,Egyro,Etilt,bias,gyroInt,p[4],kp[4] 'interesting  
  long frame[406]
  long gyro,tilt
  long biasF,QgyroF,QaccelF,RaccelF,dtF,dt,Qgyro,Qaccel,Raccel,f1,f100k 'kalman
  long stack[85] '55 needed
  long gAvg[gAvgNum+1]
OBJ
  i2c:  "i2cObject"
  m:    "FloatMath"
  vp :  "Conduit"
  qs:   "QuickSample"
pub main|nCnt,stack1[160]
  vp.register(qs.sampleINA(@frame,1)) 'sample INA with 1 cog up to 20Mhz
  vp.config(string("var:io,accel,gyro,tilt,bias,gyroInt(acdc=ac),p1,p2,p3,p4,k1,k2,k3,k4"))  
  vp.config(string("lsa:view=io,timescale=1ms,trigger=io[6]r")) 
  vp.config(string("dso:view=[accel,tilt],timescale=1s"))
  vp.config(string("start:dso"))
  vp.share(@accel,@gyroInt+8*4)

  waitcnt(cnt+clkfreq*1)
  start
  ncnt:=cnt
  repeat
    update1(80_000)
    Etilt:=update2(@Egyro)    
    waitcnt(nCnt+=clkfreq/200) 'update tilt every 5ms}}   
pub start|a,b,c,d
  longfill(@accel,9,0)
  longfill(@gavg,gAvgNum,0)
  dira[gyroOutP]~~
  ctra := (%10101 << 26 ) | (%001 << 23) | GyroInP ' set up counter for gyroin, measured lag till pulseout
  frqa:=2

  bias~
  'average gyro
  repeat 10  
    update1(80_000)
    waitcnt(GyroDone) 
    bias+= -(phsa-gyroO)
    outa[GyroOutP]~
    waitcnt(cnt+clkfreq/200) 'update tilt every 5ms}}  
  bias/=10    

  cognew(updateBias,@stack)
  repeat while accel==0 'wait till accel read in
  tilt:=accel
pub update1(gyroTime)
  outa[GyroOutP]~~
  phsa~
  GyroDone:=cnt+gyroTime
pub update2(gyroPtr)|a
  waitcnt(GyroDone) 
  gyro:= (phsa-gyroO)
  gyroInt+=gyro
  outa[GyroOutP]~
  a:=gyro-bias
  tilt+=a 'bias changed by accel/kalman every 20ms
  gavg[gAvgNum]:=a    
  longmove(@gavg,@gavg+4,gAvgNum) 'shift left
  long[gyroPtr]:=a'+=a-gavg
  return tilt
pub updateBias|a,ncnt
  a:=i2c.Init(accelSDAP, accelSCLP, true)  'true if ok
  i2c.writeLocation(ACC3D_Addr,$20,%1101_0111 ,8,8) 'ctrl_reg1 (pg 27):power on, 160hz, no self test, all axis on
  i2c.writeLocation(ACC3D_Addr,$21,%0010_0000 ,8,8) 'ctrl_reg2 (pg 27):2g, update continuously, big endian, no boot, 12bit
  i2c.writeLocation(ACC3D_Addr,$22,%0000_0000 ,8,8) 'ctrl_reg3 (pg 28):no filters
  StartKalman      

  ncnt:=cnt
  repeat
    a:=i2c.readLocation(ACC3D_Addr,$28 ,8,8)<<8+i2c.readLocation(ACC3D_Addr,$29 ,8,8) 'outxl,outxh
    if a>32000
      accel:=800*(a-65536)
    else
      accel:=800*a
    doKalman
    waitcnt(ncnt+=biasUpdate) '20ms
pub StartKalman
  biasF:=m.ffloat(bias)
  dt:=50
  Qaccel:=1
  Qgyro:=0
  Raccel:=10000
  QgyroF:=m.fdiv(m.ffloat(Qgyro),m.ffloat(1))
  QaccelF:=m.fdiv(m.ffloat(Qaccel),m.ffloat(1))
  RaccelF:=m.fdiv(m.ffloat(RAccel),m.ffloat(1)) 
  dtF:=m.fdiv(m.ffloat(1),m.ffloat(dt))
  p[0]:=QgyroF
  p[1]:=m.fmul(QaccelF,dtF)
  p[2]:=m.fmul(QaccelF,dtF)
  p[3]:=QaccelF
  f1:=m.ffloat(1)
  f100k:=m.ffloat(100000)   
pub doKalman|temp,kk[4],GyroF,AccelF,k1
  p[0]:=m.fadd(p[0],m.fadd(m.fmul(m.fneg(m.fadd(p[1],p[2])),dtF),QaccelF))
  temp:= m.fmul(m.fneg(p[3]),dtF)
  p[1]:=m.fadd(p[1],temp)
  p[2]:=m.fadd(p[2],temp)
  p[3]:=m.fadd(p[3],QgyroF)
  temp:=m.fdiv(f1,m.fadd(RaccelF,p[0]))
  kk[0]:=m.fmul(p[0],temp)
  kk[2]:=m.fmul(p[2],temp)
  temp:=m.fsub(m.ffloat(accel),m.ffloat(tilt))
  tilt+=m.fround(m.fmul(kk[0],temp))

  BiasF:=m.fadd(BiasF,m.fmul(kk[2],temp))
  p[3]:=m.fsub(p[3],m.fmul(kk[2],p[1]))
  p[2]:=m.fsub(p[2],m.fmul(kk[2],p[0]))
  p[1]:=m.fsub(p[1],m.fmul(kk[0],p[1]))
  p[0]:=m.fsub(p[0],m.fmul(kk[0],p[0]))
  bias:=m.fround(biasf)
  kp[0]:=m.fround(m.fmul(p[0],f100k))
  kp[1]:=m.fround(m.fmul(p[1],f100k))
  kp[2]:=m.fround(m.fmul(p[2],f100k))
  kp[3]:=m.fround(m.fmul(p[3],f100k))     