 
CON
  _clkmode = xtal1 + pll16x    ' Set Clock Speed
  _xinfreq = 5_000_000    

' ************************
' * Pin Assignments      *
' ************************
{ *********** The real configuration *******************GWM
   SERVO_1      =  0  ' bypass 1 servo 
   SERVO_2      =  1  ' bypass 2 servo
   SERVO_3      =  2  ' return air servo
   DS1620In_CLK =  3  ' Inside DS1620 on JP5 Clock Pin - Inside Peltier
   DS1620In_DQ  =  4  ' Inside DS1620 on JP5 Data Pin
   DS1620In_RST =  5  ' Inside DS1620 on JP5 Reset Pin
   UNUSED_1     =  6
   UNUSED_2     =  7
   NET_RX       =  8  ' Serial comm IN         
   NET_TX       =  9  ' Serial comm OUT
   DS1620Out_CLK= 10  ' Outside DS1620 on JP8 Clock Pin - Outside Peltier
   DS1620Out_DQ = 11  ' Outside DS1620 on JP8 Data Pin
   UNUSED_3     = 12
   UNUSED_4     = 13
   UNUSED_5     = 14
   UNUSED_6     = 15
   LED_ACTIVITY = 16  ' Indicates Activity
   LED_YELLOW   = 17  ' misc Indicator   
   XFAN         = 18  ' power FET for External fan
   IFAN         = 19  ' power FET for Internal fan
   FET          = 20  ' power FET for Peltier
   RELAY        = 21  ' to relay coil driver
   LIGHT_RED    = 22  ' Red up light
   LIGHT_BLUE   = 23  ' Blue down light
   SHT11_CLK    = 24  ' SHT11 combo temp/humidity sensor Outside Ambient Air Temp
   SHT11_DATA   = 25  ' SHT11 combo temp/humidity sensor                      
   DS1620Out_RST= 26  ' Outside DS1620 on JP8 Reset Pin
   UNUSED_7     = 27
   EEPROM_SCL   = 28  ' Program storage
   EEPROM_SDA   = 29
   CONSOLE_TX   = 30  ' Programming/Debug PC interface
   CONSOLE_RX   = 31                  
}
'  ************ temporary proto config GWM
   SERVO_1      =  13  ' bypass 1 servo 
   SERVO_2      =  14 ' bypass 2 servo
   SERVO_3      =  15 ' return air servo
   DS1620In_CLK =  3  ' Inside DS1620 on JP5 Clock Pin - Inside Peltier
   DS1620In_DQ  =  24  ' Inside DS1620 on JP5 Data Pin
   DS1620In_RST =  25  ' Inside DS1620 on JP5 Reset Pin
'   UNUSED_1     =  6
'   UNUSED_2     =  7
   NET_RX       =  6  ' Serial comm IN         
   NET_TX       =  7  ' Serial comm OUT
   DS1620Out_CLK= 10  ' Outside DS1620 on JP8 Clock Pin - Outside Peltier
   DS1620Out_DQ = 11  ' Outside DS1620 on JP8 Data Pin
   UNUSED_3     = 12
'   UNUSED_4     = 13
'   UNUSED_5     = 14
'   UNUSED_6     = 15
   LED_ACTIVITY = 16  ' Indicates Activity
   LED_YELLOW   = 17  ' misc Indicator   
   XFAN         = 18  ' power FET for External fan
   IFAN         = 19  ' power FET for Internal fan
   FET          = 20  ' power FET for Peltier
   RELAY        = 21  ' to relay coil driver
   LIGHT_RED    = 22  ' Red up light
   LIGHT_BLUE   = 23  ' Blue down light
   SHT11_CLK    =  4  ' SHT11 combo temp/humidity sensor Outside Ambient Air Temp
   SHT11_DATA   =  5  ' SHT11 combo temp/humidity sensor                      
   DS1620Out_RST= 26  ' Outside DS1620 on JP8 Reset Pin
   UNUSED_7     = 27
   EEPROM_SCL   = 28  ' Program storage
   EEPROM_SDA   = 29
   CONSOLE_TX   = 30  ' Programming/Debug PC interface
   CONSOLE_RX   = 31                  

   cntMin = 400      ' Minimum waitcnt value to prevent lock-up


' ************************
' * Objects              *
' ************************
OBJ
   DBG   : "BS2_Functions"    ' Create BS2 Object for debugging
'   DBG   : "NO_Debugging"    ' Disable debugging with no operation
   SENSOR: "HVAC_Sensing_12" ' sensor reading

VAR
  long currExternalTemp10X
  long currExternalHumid
     
PUB PollSensors
   DBG.start(CONSOLE_RX,CONSOLE_TX) ' Initialize BS2 Object timing, Rx and Tx pins for DEBUG
   DBG.Debug_str(string(13,11,"PollSensors",13, 11)) 
   SENSOR.InitSHT11(SHT11_DATA, SHT11_CLK)                        ' start sensirion object
   DBG.Debug_str(string(13,11,"SHT Init",13, 11))
   repeat
      DBG.Debug_Str(string(" Temp= "))   
'      currExternalTemp10X := SENSOR.ReadSHT11Temperature
'      currExternalHumid := SENSOR.ReadSHT11Humidity
      currExternalTemp10X := SENSOR.RawSHT11Temperature
      currExternalHumid := SENSOR.RawSHT11Humidity 
      
      DBG.Debug_Dec(currExternalTemp10X)
      DBG.Debug_Str(string(" Humid= "))
      DBG.Debug_Dec(currExternalHumid)            
      DBG.Debug_cr                     
            
      PauseMSec(1000)    

PUB PauseMSec(Delay) | clkCycles
   clkCycles := clkfreq / 1000 * Delay #> cntMin
   waitcnt(clkCycles + cnt)

PUB PauseSeconds(Delay)
   repeat Delay
      PauseMSec(1000)   